;;; -*- Mode: Lisp; Syntax:Common-Lisp; Package:PENMAN -*-
(in-package :penman)


(defun adjective-lexical-word-class-q-code (lex-entry)
  (lexical-class-ascertainer lex-entry '(er-est r-st *er-*est)))

(defun nerb-lexical-word-class-q-code (lex-entry)
  (lexical-class-ascertainer lex-entry '(noun verb)))


(defun noun-lexical-word-class-q-code (lex-entry)
  (lexical-class-ascertainer lex-entry '(s es)))



(defun verb-lexical-regularity-q-code (lex-entry)
  (case (lexical-class-ascertainer lex-entry '(regular irr *-irr s-irr es-irr))
    (irr 'irregular)
    ((*-irr s-irr es-irr) 'semi)
    (regular 'regular)))


(defun verb-class-q-code (lex-entry)
  (lexical-class-ascertainer lex-entry '(Es-Ed S-*ed S-Ed S-d *-Irr S-irr Es-Irr)))

(defun second-final-letter-q-code (lex-entry)
  (let* ((spelling (lexical-item-spelling (gethash lex-entry lexicon)))
	 (chopped-length (1- (length spelling))))
    (if (member (subseq spelling (1- chopped-length) chopped-length) 
		'("a" "e" "o" "u")
		:test #'string-equal)
	'aeou
	'non-aeou)))

(defun final-letter-y-q-code (lex-entry)
  (let* ((spelling (lexical-item-spelling (gethash lex-entry lexicon)))
	 (chopped-length (1- (length spelling))))
    (if (string-equal (subseq spelling chopped-length (length spelling))
		      "y")
	'y
	'non-y)))

(defun final-letter-e-q-code (lex-entry)
  (let* ((spelling (lexical-item-spelling (gethash lex-entry lexicon)))
	 (chopped-length (1- (length spelling))))
    (if (string-equal (subseq spelling chopped-length (length spelling))
		      "e")
	'final-e
	'non-final-e)))

(defun exist-selected-stem-q-code (function)
  (if (and *activate-word-rank-and-below* 
	   (find-association function 'term))
      'stem
      'no-stem))
